[linux device driver]Chapter 03:scull_load中涉及到的bash命令 exit

用途说明

exit命令用于退出当前shell,在shell脚本中可以终止当前脚本执行。

 

常用参数

格式:exit n

退出。设置退出码为n。(Cause the shell to exit with a status of n.)

 

格式:exit

退出。退出码不变,即为最后一个命令的退出码。(If n is omitted, the exit status is that of the  last  command executed. )

 

格式:$?

上一个命令的退出码。

 

格式:trap "commands" EXIT

退出时执行commands指定的命令。( A trap on EXIT is executed before the shell terminates.)

 

退出码(exit status,或exit code)的约定:

0表示成功(Zero - Success)

非0表示失败(Non-Zero  - Failure)

2表示用法不当(Incorrect Usage)

127表示命令没有找到(Command Not Found)

126表示不是可执行的(Not an executable)

>=128 信号产生

 

man 3 exit 写道
The C standard specifies two constants, EXIT_SUCCESS and EXIT_FAILURE, that may be passed to exit() to indicate
successful or unsuccessful termination, respectively.
 

以下摘自/usr/include/stdlib.h

C代码   收藏代码
  1. #define EXIT_FAILURE    1       /* Failing exit status.  */  
  2. #define EXIT_SUCCESS    0       /* Successful exit status.  */  

 

BSD试图对退出码标准化。

man 3 exit 写道
BSD has attempted to standardize exit codes; see the file <sysexits.h>.
 

 

以下摘自/usr/include/sysexits.h

C代码   收藏代码
  1. #define EX_OK           0       /* successful termination */  
  2.   
  3. #define EX__BASE        64      /* base value for error messages */  
  4.   
  5. #define EX_USAGE        64      /* command line usage error */  
  6. #define EX_DATAERR      65      /* data format error */  
  7. #define EX_NOINPUT      66      /* cannot open input */  
  8. #define EX_NOUSER       67      /* addressee unknown */  
  9. #define EX_NOHOST       68      /* host name unknown */  
  10. #define EX_UNAVAILABLE  69      /* service unavailable */  
  11. #define EX_SOFTWARE     70      /* internal software error */  
  12. #define EX_OSERR        71      /* system error (e.g., can't fork) */  
  13. #define EX_OSFILE       72      /* critical OS file missing */  
  14. #define EX_CANTCREAT    73      /* can't create (user) output file */  
  15. #define EX_IOERR        74      /* input/output error */  
  16. #define EX_TEMPFAIL     75      /* temp failure; user is invited to retry */  
  17. #define EX_PROTOCOL     76      /* remote error in protocol */  
  18. #define EX_NOPERM       77      /* permission denied */  
  19. #define EX_CONFIG       78      /* configuration error */  
  20.   
  21. #define EX__MAX 78      /* maximum listed value */  
 

使用示例

示例一 退出当前shell

[root@new55 ~]# 
[root@new55 ~]# exit 
logout

 

示例二 在脚本中,进入脚本所在目录,否则退出

Bash代码   收藏代码
  1. cd $(dirname $0) || exit 1  

 

示例三 在脚本中,判断参数数量,不匹配就打印使用方式,退出

Bash代码   收藏代码
  1. if [ "$#" -ne "2" ]; then  
  2.     echo "usage: $0 <area> <hours>"  
  3.     exit 2  
  4. fi  

 

示例四 在脚本中,退出时删除临时文件

Bash代码   收藏代码
  1. trap "rm -f tmpfile; echo Bye." EXIT  

 

示例五 检查上一命令的退出码

Bash代码   收藏代码
  1. ./mycommand.sh  
  2. EXCODE=$?  
  3. if [ "$EXCODE" == "0" ]; then  
  4.     echo "O.K"  
  5. fi  
 --------------------------------------------英文解释---------------------------

The exit command terminates a script, just as in a C program. It can also return a value, which is available to the script's parent process.

Every command returns an exit status (sometimes referred to as a return status or exit code). A successful command returns a 0, while an unsuccessful one returns a non-zerovalue that usually can be interpreted as an error code. Well-behaved UNIX commands, programs, and utilities return a 0 exit code upon successful completion, though there are some exceptions.

Likewise, functions within a script and the script itself return an exit status. The last command executed in the function or script determines the exit status. Within a script, anexit nnn command may be used to deliver an nnn exit status to the shell (nnn must be an integer in the 0 - 255 range).

Note

When a script ends with an exit that has no parameter, the exit status of the script is the exit status of the last command executed in the script (previous to theexit).

#!/bin/bash

COMMAND_1

. . .

COMMAND_LAST

# Will exit with status of last command.

exit

The equivalent of a bare exit is exit $? or even just omitting the exit.

#!/bin/bash

COMMAND_1

. . .

COMMAND_LAST

# Will exit with status of last command.

exit $?
#!/bin/bash

COMMAND1

. . . 

COMMAND_LAST

# Will exit with status of last command.

$? reads the exit status of the last command executed. After a function returns, $? gives the exit status of the last command executed in the function. This is Bash's way of giving functions a "return value." [1]

Following the execution of a pipe, a $? gives the exit status of the last command executed.

After a script terminates, a $? from the command-line gives the exit status of the script, that is, the last command executed in the script, which is, by convention, 0 on success or an integer in the range 1 - 255 on error.

Example 6-1. exit / exit status

#!/bin/bash

echo hello
echo $?    # Exit status 0 returned because command executed successfully.

lskdf      # Unrecognized command.
echo $?    # Non-zero exit status returned -- command failed to execute.

echo

exit 113   # Will return 113 to shell.
           # To verify this, type "echo $?" after script terminates.

#  By convention, an 'exit 0' indicates success,
#+ while a non-zero exit value means an error or anomalous condition.
#  See the "Exit Codes With Special Meanings" appendix.

$? is especially useful for testing the result of a command in a script (see Example 16-35and Example 16-20).

Note

The !, the logical not qualifier, reverses the outcome of a test or command, and this affects its exit status.

Example 6-2. Negating a condition using !

true    # The "true" builtin.
echo "exit status of \"true\" = $?"     # 0

! true
echo "exit status of \"! true\" = $?"   # 1
# Note that the "!" needs a space between it and the command.
#    !true   leads to a "command not found" error
#
# The '!' operator prefixing a command invokes the Bash history mechanism.

true
!true
# No error this time, but no negation either.
# It just repeats the previous command (true).


# =========================================================== #
# Preceding a _pipe_ with ! inverts the exit status returned.
ls | bogus_command     # bash: bogus_command: command not found
echo $?                # 127

! ls | bogus_command   # bash: bogus_command: command not found
echo $?                # 0
# Note that the ! does not change the execution of the pipe.
# Only the exit status changes.
# =========================================================== #

# Thanks, Stéphane Chazelas and Kristopher Newsome.

Caution

Certain exit status codes have reserved meanings and should not be user-specified in a script.


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值